#include "Affichage.h"

#include <stdio.h>
#include <string.h>
#include "text.h"

float DmeriParal[51][2];	// For grids drawing optimisation

// precalculation of the grid points
void InitMeriParal(void)
{	for(int j=0;j<51;j++)
	{	DmeriParal[j][1]=cos(j*2*PI/50)*20;
		DmeriParal[j][2]=sin(j*2*PI/50)*20;
	}
}

// Draw the cardinals points : N S E O and Z (Zentih) N (Nadir)
void AfficheCardinaux(void)
{	glPushMatrix();
	glColor3f(0.8f, 0.1f, 0.1f);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D,texIds[6]);		//Nord
	glTranslatef(0.0f,0.0f,30.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f( 1.0f,-1.0f,0.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(-1.0f,-1.0f,0.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(-1.0f, 1.0f,0.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f( 1.0f, 1.0f,0.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[7]);	//Sud
	glTranslatef(0.0f,0.0f,-60.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-1.0f,-1.0f,0.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f( 1.0f,-1.0f,0.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f( 1.0f, 1.0f,0.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-1.0f, 1.0f,0.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[9]);	//Ouest
	glTranslatef(30.0f,0.0f,30.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(0.0f,-1.0f,-1.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(0.0f,-1.0f, 1.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(0.0f, 1.0f, 1.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(0.0f, 1.0f,-1.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[8]);	//Est
	glTranslatef(-60.0f,0.0f,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(0.0f,-1.0f, 1.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(0.0f,-1.0f,-1.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(0.0f, 1.0f,-1.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(0.0f, 1.0f, 1.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[10]);	//Zenith
	glTranslatef(30.0f,30.0f,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f( 1.0f, 0.0f,-1.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f( 1.0f, 0.0f, 1.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(-1.0f, 0.0f, 1.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-1.0f, 0.0f,-1.0f);	// Haut Gauche
	glEnd ();

	glBindTexture(GL_TEXTURE_2D, texIds[11]);	//Nadir
	glTranslatef(0.0f,-60.0f,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f( 1.0f, 0.0f,-1.0f);	// Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f( 1.0f, 0.0f, 1.0f);	// Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(-1.0f, 0.0f, 1.0f);	// Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-1.0f, 0.0f,-1.0f);	// Haut Gauche
	glEnd ();
	glPopMatrix();
}

// Draw the milky way : used too to 'clear' the buffer
void AfficheVoieLactee(void)
{	glPushMatrix();
	glColor3f(0.05f-coefciel, 0.05f-coefciel, 0.1f-coefciel);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, texIds[2]);
	glRotatef(206,1,0,0);
	glRotatef(-16,0,1,0);
	glRotatef(-84,0,0,1);
	GLUquadricObj * VoieLactee=gluNewQuadric();
	gluQuadricTexture(VoieLactee,GL_TRUE);
	gluSphere(VoieLactee,1000,15,15);
	gluDeleteQuadric(VoieLactee);
	glPopMatrix();
}

// Draw the equatorial merididians
void AfficheMeridiens(void)
{	glPushMatrix();	
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	//glEnable (GL_LINE_STIPPLE);
	//glLineStipple (1, 0x0101);  /*  dotted  */
	//glLineStipple (1, 0x00FF);  /*  dashed  */
	glLineStipple (1, 0x1C47);  /*  dash/dot/dash  */
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.12*coef+0.08,0.015*coef+0.1,0.015*coef+0.1);
	for(int i=0;i<12;i++)
	{	glRotatef(360/24,0,1,0);
		for(int j=0;j<50;j++)
		{	glBegin (GL_LINES);
				glVertex3f(DmeriParal[j][1],DmeriParal[j][2], 0.0f);
				glVertex3f(DmeriParal[j+1][1],DmeriParal[j+1][2], 0.0f);
			glEnd ();
		}
	}
	//glDisable (GL_LINE_STIPPLE);
	glPopMatrix();
}

// Draw the azimuthal merididians
void AfficheMeridiensAzimuth(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glEnable (GL_LINE_STIPPLE);
	//glLineStipple (1, 0x0101);  /*  dotted  */
	glLineStipple (1, 0x00FF);  /*  dashed  */
	//glLineStipple (1, 0x1C47);  /*  dash/dot/dash  */
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.015*coef+0.1,0.12*coef+0.08,0.015*coef+0.1);
	for(int i=0;i<12;i++)
	{	glRotatef(360/24,0,1,0);
		for(int j=0;j<50;j++)
		{	glBegin (GL_LINES);
				glVertex3f(DmeriParal[j][1],DmeriParal[j][2], 0.0f);
				glVertex3f(DmeriParal[j+1][1],DmeriParal[j+1][2], 0.0f);
			glEnd ();
		}
	}
	glDisable (GL_LINE_STIPPLE);
	glPopMatrix();
}

// Draw the equatorial parallels
void AfficheParalleles(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	//glEnable (GL_LINE_STIPPLE);
	//glLineStipple (1, 0x0101);  /*  dotted  */
	//glLineStipple (1, 0x00FF);  /*  dashed  */
	glLineStipple (1, 0x1C47);  /*  dash/dot/dash  */
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.2*coef+0.1,0.025*coef+0.1,0.025*coef+0.1);
	for(int i=0;i<18;i++)
	{	for(int j=0;j<50;j++)
		{	float r=cos((i-9)*PI/18);
			float h=sin((i-9)*PI/18)*20;
			glBegin (GL_LINES);
				glVertex3f(DmeriParal[j][1]*r,h,DmeriParal[j][2]*r);
				glVertex3f(DmeriParal[j+1][1]*r,h,DmeriParal[j+1][2]*r);
			glEnd ();
		}
	}
	//glDisable (GL_LINE_STIPPLE);
	glPopMatrix();
}

// Draw the azimuthal parallels
void AfficheParallelesAzimuth(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glEnable (GL_LINE_STIPPLE);
	//glLineStipple (1, 0x0101);  /*  dotted  */
	glLineStipple (1, 0x00FF);  /*  dashed  */
	//glLineStipple (1, 0x1C47);  /*  dash/dot/dash  */
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.015*coef+0.1,0.12*coef+0.08,0.015*coef+0.1);
	for(int i=0;i<18;i++)
	{	for(int j=0;j<50;j++)
		{	float r=cos((i-9)*PI/18);
			float h=sin((i-9)*PI/18)*20;
			glBegin (GL_LINES);
				glVertex3f(DmeriParal[j][1]*r,h,DmeriParal[j][2]*r);
				glVertex3f(DmeriParal[j+1][1]*r,h,DmeriParal[j+1][2]*r);
			glEnd ();
		}
	}
	glDisable (GL_LINE_STIPPLE);
	glPopMatrix();
}

// Draw the celestrial equator
void AfficheEquateurCeleste(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.2*coef+0.3,0.025*coef+0.1,0.025*coef+0.1);
	for(int j=0;j<50;j++)
	{	glBegin (GL_LINES);
			glVertex3f(DmeriParal[j][1]*20,0,DmeriParal[j][2]*20);
			glVertex3f(DmeriParal[j+1][1]*20,0,DmeriParal[j+1][2]*20);
		glEnd ();
	}
	glPopMatrix();
}

// Draw the ecliptic line  !!!!  erreur !!!!!   revoir
void AfficheEcliptique(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.025*coef+0.2,0.025*coef+0.2,0.025*coef+0.0);
	
	const double centuries = Astro::toMillenia( JDay );
	const double obliquity = AstroOps::meanObliquity( centuries );
	glRotatef(obliquity*180/PI,0,0,1);
	for(int j=0;j<50;j++)
	{	glBegin (GL_LINES);
			glVertex3f(DmeriParal[j][1]*20,0,DmeriParal[j][2]*20);
			glVertex3f(DmeriParal[j+1][1]*20,0,DmeriParal[j+1][2]*20);
		glEnd ();
	}
	glPopMatrix();
}

// Draw the horizon fog
void AfficheHorizon(void)
{	glPushMatrix();
	glColor3f(0.1f+0.2f*coefciel, 0.15f+0.2f*coefciel, 0.15f+0.2f*coefciel);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, texIds[3]);
	glTranslatef(0,-20,0);
	glRotatef(-90,1,0,0);
	GLUquadricObj * Horizon=gluNewQuadric();
	gluQuadricTexture(Horizon,GL_TRUE);
	gluCylinder(Horizon,800,800,300,10,1);
	gluDeleteQuadric(Horizon);
	glPopMatrix();	
}

// Draw the horizontal line
void AfficheHoriLine(void)
{	glPushMatrix();
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glColor3f(0.15,0.15,0.25);
	
	glBegin (GL_LINES);
		glVertex2f(0,17.*winW/1024);
		glVertex2f(winW,17.*winW/1024);
	glEnd ();

	glPopMatrix();
}

// Draw a point... (used for tests)
void AffichePoint(float X,float Y,float Z)
{		glColor3f(0.5, 1.0, 0.5);
		glDisable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glPointSize(5);
		glBegin(GL_POINTS);
			glVertex3f(X,Y,Z);
		glEnd();
}

// Draw the pointer
void AffichePointeur(vec3_t obj, float size, vec3_t RGB, int ObjType)
{	double x,y;
	Projette(obj[0],obj[1],obj[2],x,y);
	setOrthographicProjection(winW, winH);
	glPushMatrix();
	glLoadIdentity();
	glColor3fv(RGB);
	rotPointer++;
	if (ObjType==0 )
	{	glBindTexture (GL_TEXTURE_2D, texIds[12]);
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glTranslatef(x, winH-y,0.0f);
		glRotatef(rotPointer/2,0,0,1);
		glBegin(GL_QUADS );
			glTexCoord2f(0.0f,0.0f);	glVertex3f(-13,-13,0);		//Bas Gauche
			glTexCoord2f(1.0f,0.0f);	glVertex3f(13,-13,0);		//Bas Droite
			glTexCoord2f(1.0f,1.0f);	glVertex3f(13,13,0);		//Haut Droit
			glTexCoord2f(0.0f,1.0f);	glVertex3f(-13,13,0);		//Haut Gauche
		glEnd ();
	}
	if (ObjType==1 || ObjType==2)
	{	if (ObjType==2)
		{	glBindTexture(GL_TEXTURE_2D, texIds[26]);
			size+=Ouv/4;
			size+=size*sin((float)rotPointer/20)/200*Ouv;
		}
		if (ObjType==1)
		{	glBindTexture(GL_TEXTURE_2D, texIds[27]);
			size+=size*sin((float)rotPointer/20)*Ouv/200;
		}

		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glTranslatef(x, winH-y,0.0f);
		if (ObjType==2) glRotatef(rotPointer/2,0,0,-1);

		glTranslatef(-size/2, -size/2,0.0f);
		glRotatef(90,0,0,1);
		glBegin(GL_QUADS );
			glTexCoord2f(0.0f,0.0f);	glVertex3f(-10,-10,0);		//Bas Gauche
			glTexCoord2f(1.0f,0.0f);	glVertex3f(10,-10,0);		//Bas Droite
			glTexCoord2f(1.0f,1.0f);	glVertex3f(10,10,0);		//Haut Droit
			glTexCoord2f(0.0f,1.0f);	glVertex3f(-10,10,0);		//Haut Gauche
		glEnd ();

		glRotatef(-90,0,0,1);
		glTranslatef(0,size,0.0f);
		glBegin(GL_QUADS );
			glTexCoord2f(0.0f,0.0f);	glVertex3f(-10,-10,0);		//Bas Gauche
			glTexCoord2f(1.0f,0.0f);	glVertex3f(10,-10,0);		//Bas Droite
			glTexCoord2f(1.0f,1.0f);	glVertex3f(10,10,0);		//Haut Droit
			glTexCoord2f(0.0f,1.0f);	glVertex3f(-10,10,0);		//Haut Gauche
		glEnd ();

		glRotatef(-90,0,0,1);
		glTranslatef(0, size,0.0f);
		glBegin(GL_QUADS );
			glTexCoord2f(0.0f,0.0f);	glVertex3f(-10,-10,0);		//Bas Gauche
			glTexCoord2f(1.0f,0.0f);	glVertex3f(10,-10,0);		//Bas Droite
			glTexCoord2f(1.0f,1.0f);	glVertex3f(10,10,0);		//Haut Droit
			glTexCoord2f(0.0f,1.0f);	glVertex3f(-10,10,0);		//Haut Gauche
		glEnd ();

		glRotatef(-90,0,0,1);
		glTranslatef(0,size,0);
		glBegin(GL_QUADS );
			glTexCoord2f(0.0f,0.0f);	glVertex3f(-10,-10,0);		//Bas Gauche
			glTexCoord2f(1.0f,0.0f);	glVertex3f(10,-10,0);		//Bas Droite
			glTexCoord2f(1.0f,1.0f);	glVertex3f(10,10,0);		//Haut Droit
			glTexCoord2f(0.0f,1.0f);	glVertex3f(-10,10,0);		//Haut Gauche
		glEnd ();
	}
		glPopMatrix();
		resetPerspectiveProjection();
}

/*void AfficheMenuSelect(int ObjType)
{	setOrthographicProjection(winW, winH);
	glPushMatrix();
	glLoadIdentity();

	float sizew=charSizeOf("Center",2)*1.5;
	float sizeh=lineSizeOf(2)*1.5;

	glBindTexture (GL_TEXTURE_2D, texIds[35]);
	glTranslatef(winW-sizew, winH-sizeh,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(0,sizeh,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(sizew,sizeh,0);	//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(sizew,0,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(0,0,0);			//Haut Gauche
	glEnd ();

	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glColor3f(1.0f,1.0f,1.0f);
	glPrint((sizew-charSizeOf("Center",2))/2,(sizeh-lineSizeOf(2))/2+1,"Center",2);

	glPopMatrix();
	resetPerspectiveProjection();
}*/

// Draw the clikable menu
void AfficheMenu(void)
{	setOrthographicProjection(winW, winH);
	glPushMatrix();
	glLoadIdentity();
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	float size=16*winW/1024;
	if (FlagConst) glColor3f(0.4,0.4,0.8); else glColor3f(0.12,0.12,0.40);	
	glBindTexture (GL_TEXTURE_2D, texIds[13]);
	glTranslatef(size, winH-size,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagNomConst) glColor3f(0.4,0.4,0.8); else glColor3f(0.12,0.12,0.40);	
	glBindTexture (GL_TEXTURE_2D, texIds[14]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagNeb) glColor3f(0.45f,0.45f,0.45f);  else glColor3f(0.2f,0.2f,0.2f);
	glBindTexture (GL_TEXTURE_2D, texIds[24]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagLignes) glColor3f(0.8,0.4,0.4);  else glColor3f(0.40,0.13,0.13);
	glBindTexture (GL_TEXTURE_2D, texIds[15]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagLignesAzimuth) glColor3f(0.32,0.46,0.32);  else glColor3f(0.08,0.2,0.08);
	glBindTexture (GL_TEXTURE_2D, texIds[15]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagCardinaux) glColor3f(0.8,0.4,0.4);  else glColor3f(0.40,0.13,0.13);
	glBindTexture (GL_TEXTURE_2D, texIds[20]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagSol) glColor3f(0.65,0.65,0.65);  else glColor3f(0.3,0.3,0.3);
	glBindTexture (GL_TEXTURE_2D, texIds[16]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagHorizon) glColor3f(0.55,0.55,0.55);  else glColor3f(0.2,0.2,0.2);
	glBindTexture (GL_TEXTURE_2D, texIds[19]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagCiel) glColor3f(0.5,0.5,0.5);  else glColor3f(0.2,0.2,0.2);
	glBindTexture (GL_TEXTURE_2D, texIds[21]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (Flaganim) glColor3f(0.5,0.5,0.5);  else glColor3f(0.2,0.2,0.2);
	glBindTexture (GL_TEXTURE_2D, texIds[17]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (Flaganimmin) glColor3f(0.5,0.5,0.5);  else glColor3f(0.2,0.2,0.2);
	glBindTexture (GL_TEXTURE_2D, texIds[18]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagTexte) glColor3f(0.1f,0.55f,0.6f);  else glColor3f(0.0f,0.2f,0.22f);
	glBindTexture (GL_TEXTURE_2D, texIds[22]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	if (FlagHelp) glColor3f(0.1f,0.55f,0.6f);  else glColor3f(0.0f,0.2f,0.22f);
	glBindTexture (GL_TEXTURE_2D, texIds[23]);
	glTranslatef(size*2,0,0.0f);
	glBegin(GL_QUADS );
		glTexCoord2f(0.0f,0.0f);	glVertex3f(-size,size,0);		//Bas Gauche
		glTexCoord2f(1.0f,0.0f);	glVertex3f(size,size,0);		//Bas Droite
		glTexCoord2f(1.0f,1.0f);	glVertex3f(size,-size,0);		//Haut Droit
		glTexCoord2f(0.0f,1.0f);	glVertex3f(-size,-size,0);		//Haut Gauche
	glEnd ();

	glPopMatrix();
	resetPerspectiveProjection();
}

// Draw the mountains with a few pieces of a big texture
void AfficheDecor(int nb)
{	glPushMatrix();
	glColor3f(0.05f+0.5f*coefciel, 0.08f+0.8f*coefciel, 0.05f+0.5f*coefciel);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);

	float delta=1.98915/nb; // environ egal  sin((float)(PI/8))/cos((float)(PI/8))*10/2;
	for (int ntex=0;ntex<4*nb;ntex++)
	{	glBindTexture(GL_TEXTURE_2D, texIds[31+ntex%4]);
		for (int nDecoupe=0;nDecoupe<4;nDecoupe++)
		{	glBegin(GL_QUADS );
				//Haut Gauche
				glTexCoord2f((float)nDecoupe/4,1.0f);		
				glVertex3f(10.0f,1.5f,-delta);
				//Bas Gauche
				glTexCoord2f((float)nDecoupe/4,0.0f);		
				glVertex3f(10.0f,-1.0f,-delta);
				//Bas Droit
				glTexCoord2f((float)nDecoupe/4+0.25,0.0f);
				glVertex3f(10.0f,-1.0f,delta);
				//Haut Droit
				glTexCoord2f((float)nDecoupe/4+0.25,1.0f);
				glVertex3f(10.0f,1.5f,delta);
			glEnd ();
			glRotatef(22.5/nb,0,-1,0);
		}
	}
	glPopMatrix();
}

// Draw the sky
void AfficheCiel(void)
{	glPushMatrix();	
	glColor3f(0.6f*coefciel, 0.6f*coefciel, 1.0f*coefciel);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, texIds[4]);

	glRotatef(-90,1,0,0);
	GLUquadricObj * Ciel=gluNewQuadric();
	gluQuadricTexture(Ciel,GL_TRUE);
	gluSphere(Ciel,10,20,20);
	gluDeleteQuadric(Ciel);
	glPopMatrix();
}

// Draw the ground
void AfficheSol(void)
{	glPushMatrix();
	glColor3f(0.08+0.6f*coefciel, 0.08+0.6f*coefciel, 0.15+0.7f*coefciel);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glBindTexture(GL_TEXTURE_2D, texIds[1]);
	glBegin (GL_QUADS);
        glTexCoord2f (0.0f,0.0f);
        glVertex3f (-1000.0f, -5.0f, -1000.0f);
        glTexCoord2f (1.0f, 0.0f);
		glVertex3f(-1000.0f, -5.0f,  1000.0f);
        glTexCoord2f (1.0f, 1.0f);
		glVertex3f( 1000.0f, -5.0f,  1000.0f);
        glTexCoord2f (0.0f, 1.0f);
		glVertex3f( 1000.0f, -5.0f, -1000.0f);
    glEnd ();
	glPopMatrix();
}


// Print help screen
void AfficheHelp(void)
{	glColor3f(0.5f,0.5f,0.8f);
	int xt=(winW-140*(float)winW/1024)/2,yt=(winH-430*(float)winW/1024)/2;
	glPrint(xt,yt,"4 Directions : Deplacement RA/DE",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"Page Up/Down : Zoom",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"Left Mouse Clic : Select Star",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"Right Mouse Clic  : Clear Pointer",FONT1);
	yt+=lineSizeOf(FONT1)*2;
	

	glPrint(xt,yt,"H   : Help",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"I   : Info",FONT1);
	yt+=lineSizeOf(FONT1)*2;

	glPrint(xt,yt,"K   : Drawing of the Constellations",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"N   : Names of the Constellations",FONT1);
	yt+=lineSizeOf(FONT1)*2;

	glPrint(xt,yt,"L   : Equatorial Grid",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"J   : Azimuthal Grid",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"A   : Cardinal Points",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"R   : Ecliptic",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"F   : Celestial Equator",FONT1);
	yt+=lineSizeOf(FONT1)*2;

	glPrint(xt,yt,"S   : Ground",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"Z   : Fog",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"C   : Sky",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"+   : Inrease Sky Brigthness",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"-   : Decrease Sky Brigthness",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"E   : Etoiles",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"D   : Messier Objects",FONT1);
	yt+=lineSizeOf(FONT1)*2;


	glPrint(xt,yt,"1   : Real Time",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"0   : Accelered Time",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"T   : Text",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"M   : Menu",FONT1);
	yt+=lineSizeOf(FONT1)*2;

	glPrint(xt,yt,"ESC : Quit",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"F1  : Full Screen",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"F2  : Windowed",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"F3-F8 : Fullscreens Modes",FONT1);
	yt+=lineSizeOf(FONT1);
	glPrint(xt,yt,"F9  : Quit Fullscreen Mode",FONT1);
	yt+=lineSizeOf(FONT1);
}

void centerPrint(int y,char * str)
{	glPrint((winW-charSizeOf(str,FONT1))/2,y,str,FONT1);
}

// Print info screen
void AfficheInfo(void)
{	glColor3f(0.8f,0.3f,0.3f);
	int yt=winH/2-180*(float)winW/1024;
	centerPrint(yt,appName);
	yt+=lineSizeOf(FONT1)*3;
	centerPrint(yt,"Copyright (c) 2002 Fabien Chereau");
	yt+=lineSizeOf(FONT1)*2;
	centerPrint(yt,"January 2002");
	yt+=lineSizeOf(FONT1)*2;
	centerPrint(yt,"Please send bug report & comments to stellarium@free.fr");
	yt+=lineSizeOf(FONT1)*3;
	centerPrint(yt,"This software is free but if you have too much");
	yt+=lineSizeOf(FONT1);
	centerPrint(yt,"money, just send it to :");
	yt+=lineSizeOf(FONT1)*2;
	centerPrint(yt,"Club Astronomie de l'INSA de Lyon");
	yt+=lineSizeOf(FONT1);
	centerPrint(yt,"20, Av. Albert Einstein");
	yt+=lineSizeOf(FONT1);
	centerPrint(yt,"69621 Villeurbanne, FRANCE");
}
