// LesConstellations.cpp: implementation of the LesConstellations class.
//
//////////////////////////////////////////////////////////////////////

// Class used to manage group of constellation

#include "LesConstellations.h"


LesConstellations::LesConstellations()
{
}

// Load from file
void LesConstellations::Charger(char * NomFichier, LesEtoiles & VouteCeleste_i)
{	ifstream fic (NomFichier,ios::in);
	if (fic.is_open())
	{	LesConstellations::Lire(fic,VouteCeleste_i);
		fic.close();
	}
}

// Destructor
LesConstellations::~LesConstellations()
{	vector<constellation *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	delete (*iter);
	}
}

// Read the dat and store in the vector of "constellation *"
int LesConstellations::Lire(ifstream & lestream, LesEtoiles & VouteCeleste_i)
{	cout << "Loading constellation data..." << endl;
	for(;;)
	{	constellation * c = new constellation;
		(*c).Lire(lestream, VouteCeleste_i);
		if (lestream.eof())
		{	delete c;
			break;
		}
		Liste.push_back(c);
	}
	return 0;
}

// Draw all the constellations in the vector
void LesConstellations::Afficher()
{	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.015*coef+0.15,0.015*coef+0.15,0.08*coef+0.15);
	vector<constellation *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	(**iter).Afficher();
	}
}

// Draw one constellation of internationnal name Abr
void LesConstellations::Afficher(char Abr[4])
{	vector<constellation *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{if (!strcmp((**iter).Abreviation,Abr)) break;}
	(**iter).AfficherSeule();
}

// Draw the names of all the constellations
void LesConstellations::AfficherNom()
{
	vector<constellation *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	(**iter).CalculeNom();
	}

	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.020*coef+0.3,0.020*coef+0.3,0.03*coef+0.5);
	setOrthographicProjection(winW, winH);
	glPushMatrix();
	glLoadIdentity();
	glEnable(GL_BLEND);
	glEnable(GL_TEXTURE_2D);
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	(**iter).AfficherNom();
	}
	glPopMatrix();
	resetPerspectiveProjection();
}
