// Nebuleuse.h: interface for the Nebuleuse class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_NEBULEUSE_H_)
#define _NEBULEUSE_H_

#define RAYON 500

#include <fstream>
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "utilitaires.h"
#include "vector.h"

using namespace std ;

//extern int texIds[500];
extern int winW,winH;
extern vec3_t XYZVision;
extern float coefciel, Ouv;
extern double ChampPrecalc;
extern bool FlagNeb;

class Nebuleuse  
{
friend class LesNebuleuses;
public:
	Nebuleuse();
	virtual ~Nebuleuse();
	int Lire(FILE *);		// Read the Nebulae data in the stream
	void Afficher();		// Draw the nebulae
	int LireTexture();
private:
	static unsigned int texCircleId;
	short posDash;
	float incLum;
	unsigned int Messier;	// Messier catalog number
	unsigned int NGC;		// NGC catalog number
	char Name[40];			// Nebulae Name
	float Mag;				// Apparent magnitude
	vec3_t XYZ;				// Cartesian position
	char Type[4];			// Nebulae type
	float RaRad;			// Right Ascention in radians
	float DecRad;			// Declinaison in radians
	float * matTransfo;		// Transformation matrix used to draw the nebulae
	float Rotation;			// Rotation pour la mettre dans le bon sens...
	float Taille;			// Taille en minute d'arc
	char Constellation[5];	// Constellation
	unsigned int TexID;		// Texture ID
	float RayonPrecalc;		// Taille Prcalcule

};

#endif // !defined(_NEBULEUSE_H_)
