// Planete.h: interface for the Planete class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_PLANETE_H_)
#define _PLANETE_H_

#define UA 149597870

#include "astroLib/AstroOps.h"
#include "astroLib/PlanetData.h"
#include "astroLib/DateOps.h"
#include "vector.h"
#include <stdio.h>
#include "utilitaires.h"
#include "Affichage.h"

#define DIST_PLANET 500

extern int winW,winH;
extern vec3_t XYZVision;
extern float Ouv;
extern float coefciel;
extern int texIds[500];

class Planete  
{
friend class LesPlanetes;
public:
	Planete(Planet LeNum);
	virtual ~Planete();
	void Calculer(double date, ObsInfo lieu, vec3_t helioPosObs);
	void Afficher(vec3_t coordLight);
private:
	void testDistance(vec3_t Pos,float &anglePlusProche, Planete * &plusProche);
	Planet num;
	char * Name;
	double Rayon;
	double RayonOrbite;
	double Distance_to_obs;
	vec3_t GeoCoord , HelioCoord , Colour;  // Coords in UA
	float RaRad;
	float DecRad;
	int TexId;
};

#endif // !defined(_PLANETE_H_)
