// Module to manage textures

#include <stdio.h>
#include "tga.h"

#define IMG_TYPE "tga"
#define TEXTURE_DIR "../textures/"

unsigned int createTexture(char * texName)
{	tga_t image;
	unsigned int texId = image.GenId();				// let OpenGL give us a texture id using the tga lib
	char fullName[128];
	sprintf(fullName,"%s%s.%s",TEXTURE_DIR,texName,IMG_TYPE);
	if (!image.Load(fullName, texId))
	{	printf("Couldn't load texture %s!!\n",fullName);
		return 0;
	}
	return texId;
}